package
{
	import flash.display.Sprite;
	import flash.events.ErrorEvent;
	import flash.events.UncaughtErrorEvent;
	import flash.text.TextField;
	import flash.utils.setTimeout;
	
	import org.domlib.test.ErrorDispatcher;
	
	
	/**
	 * 全局异常捕获测试
	 * @author DOM
	 */
	public class ErrorTest extends Sprite
	{
		public function ErrorTest()
		{
			loaderInfo.uncaughtErrorEvents.addEventListener(UncaughtErrorEvent.UNCAUGHT_ERROR,unCaughtErrorHandler);
			logText.width = logText.height = 1000;
			addChild(logText);
			setTimeout(runTest,20);
		}
		
		private var logText:TextField = new TextField();
		
		private function runTest():void
		{
			try
			{
				new ErrorDispatcher("在try...catch里的错误");//在try...catch里的错误不会触发事件。
			}
			catch(e:Error){}
			
			new ErrorDispatcher("不在try...catch里的错误");//这个错误会触发。
		}
		
		private function unCaughtErrorHandler(event:UncaughtErrorEvent):void
		{
			var message:String = "";
			if(event.error is Error)
			{
				//只有FP11.5以上才能在非debug版本中调用getStackTrace()。
				//event.error千万别做类型转换为Error(event.error),这样输出的堆栈信息会不完整。
				message = event.error.getStackTrace();
				if(!message)
					message = event.error.message;
				
			}
			else if(event.error is ErrorEvent)
			{
				message = event.error.text;
			}
			else
			{
				message = event.error.toString();
			}
			logText.appendText(message);
		}
	}
}